import { el } from "../../etc";
import { UiEventHandler, UiCpuSignalHandler, UiCpuSignal } from "../../events";
import UiComponent from "../uiComponent";

export default class TrashButton implements UiComponent {
	container: HTMLElement;
	events: UiEventHandler;
	cpu_signals: UiCpuSignalHandler;
	constructor(element: HTMLElement, events: UiEventHandler, cpu_signals: UiCpuSignalHandler) {
		this.container = element;
		this.events = events;
		this.cpu_signals = cpu_signals;
		// const trash_button = el("button").cl("nostyle").ti("Delete Code").tx("🗑").fin();

		this.container.addEventListener("click", () => this.trashClicked());
	}

	trashClicked(): void {
		if (confirm("Clear all code? Irreversible")) {
			this.cpu_signals.dispatch(UiCpuSignal.RequestCpuReset);
		}
	}
}
